#include <stdio.h>
#include "bmsfel.h"

int main( int argc, char *argv[] ) {

  if ( argc < 2 ) {
    fprintf( stderr, "Usgae : sample <bms file ...>\n", argv[0] );
    return 0;
  }
  for ( int i = 1; i < argc; ++i ) {
    BmsBms *bms;
    if ( !BmsLexer::read_file( argv[i], &bms ) ) {
      fprintf( stderr, "error read_file\n" );
      return 1;
    }
    printf( "--%s-------------------------------\n", argv[i] );
    printf( "TITLE       : %s\n", bms->get_headers()->fetch_str( "TITLE" ) );
    printf( "GENRE       : %s\n", bms->get_headers()->fetch_str( "GENRE" ) );
    printf( "ARTIST      : %s\n", bms->get_headers()->fetch_str( "ARTIST" ) );
    printf( "BPM         : %s\n", bms->get_headers()->fetch_str( "BPM" ) );
    printf( "ŏI    : %d\n", bms->get_max_bar() );

    int wav_regist_count = 0;
    int bmp_regist_count = 0;
    for ( int i = 0; i < BMS_WORD_MAX; ++i ) {
      if ( bms->get_wavs()->is_exist( BmsWord( i ) ) ) { ++wav_regist_count; }
      if ( bms->get_bmps()->is_exist( BmsWord( i ) ) ) { ++bmp_regist_count; }
    }
    printf( "WAVo^   : %d\n", wav_regist_count );
    printf( "BMPo^   : %d\n", bmp_regist_count );

    printf( "gpCHANNEL :");
    for ( BmsChannel *ch = bms->get_first_channel(); ch != NULL_CHANNEL; ch = ch->get_next() ) {
      char buf[3];
      printf( " %s", ch->get_channel_number().get_str_null( buf ) );
    }
    printf( "\n" );

    int object_count = 0;
    for ( BmsChannel *ch = bms->get_first_channel(); ch != NULL_CHANNEL; ch = ch->get_next() ) {
      for ( BmsChannel *same_ch = ch; same_ch != NULL_CHANNEL; same_ch = same_ch->get_same_next() ) {
        object_count += same_ch->get_count();
      }
    }
    printf( "IuWF  : %d\n", object_count );

    printf( "\n" );
    delete bms;
  }
  return 0;
}
