#include <windows.h>

#include "bmslsort.h"

// channelWAV or BMP̃`lǂ̊֐
static bool channel_check_wav( BmsWord channel );
static bool channel_check_bmp( BmsWord channel );

// ėpXgp֐
static void exchange_bms_list( int nth_a, int nth_b, BmsRegistArray *list, bool (*channel_check)( BmsWord ) );
// ėpXgړp֐
static void move_bms_list( int start, int end, bool up, BmsRegistArray *list, bool (*channel_check)( BmsWord ) );

// Bms̃Xg̈ړ
// startend܂łup( true =>  false =>  )Ɉړ
// ړƂɍ݂͍̂Ōɂ
static void move_bms_list_wav( int start, int end, bool up );
static void move_bms_list_bmp( int start, int end, bool up );

void get_exist_list( bool *list, bool (*channel_check)( BmsWord ) );


// str = BMS̃pX bms_pathbms_dirɃRs[
// 2,3̓Zbg邩ǂ̃tO falseȂ""ɂȂ
bool set_bms_path_dir( char *str, bool path, bool dir ) {
  if ( path ) {
    wsprintf( bms_path, "%s", str );
  }
  else { bms_path[0] = '\0'; }

  if ( dir ) {
    char drive[MAX_PATH], dir[MAX_PATH], filename[MAX_PATH], ext[MAX_PATH];
    //tpX𕪊
    _splitpath( str, drive, dir, filename, ext);

    wsprintf( bms_dir, "%s%s", drive, dir );
  }
  else { bms_dir[0] = '\0'; }

  return true;
}


// EBhE^CgύX
void set_window_title( HWND h_wnd ) {
  if ( bms_path[0] == '\0' ) { return; }
  char window_title[MAX_PATH + sizeof(APP_NAME)];
  wsprintf( window_title, "%s - %s", APP_NAME, bms_path );
  SetWindowText( h_wnd, window_title );
}


// str = pXt@Cɂ
void edit_basename( char *str ) {
  char drive[MAX_PATH], dir[MAX_PATH], filename[MAX_PATH], ext[MAX_PATH];
  _splitpath( str, drive, dir, filename, ext);
  wsprintf( str, "%s%s", filename, ext );
}


// Bms̃XĝQӏւāÃIuWFSς
void exchange_bms_list_wav( int nth_a, int nth_b ) {
  exchange_bms_list( nth_a, nth_b, bms->get_wavs(), channel_check_wav );
}
void exchange_bms_list_bmp( int nth_a, int nth_b ) {
  exchange_bms_list( nth_a, nth_b, bms->get_bmps(), channel_check_bmp );
}
// ėpXgp֐
static void exchange_bms_list( int nth_a, int nth_b, BmsRegistArray *list, bool (*channel_check)( BmsWord ) ) {
  BmsWord word_a( nth_a );
  BmsWord word_b( nth_b );

  char *str_a = list->take_at( word_a );
  char *str_b = list->take_at( word_b );

  list->overwrite_in( word_a, str_b );
  list->overwrite_in( word_b, str_a );

  int max_position = bms->get_max_position();

  for ( BmsChannel *temp_channel = bms->get_first_channel(); temp_channel != NULL_CHANNEL; temp_channel = temp_channel->get_next() ) {
    if ( channel_check( temp_channel->get_channel_number() ) ) {
      for ( BmsChannel *same_channel = temp_channel; same_channel != NULL_CHANNEL; same_channel = same_channel->get_same_next() ) {
        for ( int i = 0; i <= max_position; ++i ) {
          if ( same_channel->at( i ) == "00" ) {
            // ׂ̈ɕKv
          }
          else if ( same_channel->at( i ) == word_a ) {
            same_channel->overwrite( i, word_b );
          }
          else if ( same_channel->at( i ) == word_b ) {
            same_channel->overwrite( i, word_a );
          }
        }
      }
    }
  }
}


// Bms̃Xg̈ړ
// startend܂łup( true =>  false =>  )Ɉړ
// ړƂɍ݂͍̂Ōɂ
void move_bms_list_wav( int start, int end, bool up ) {
  move_bms_list( start, end, up, bms->get_wavs(), channel_check_wav );
}
void move_bms_list_bmp( int start, int end, bool up ) {
  move_bms_list( start, end, up, bms->get_bmps(), channel_check_bmp );
}
// ėpXgړp֐
static void move_bms_list( int start, int end, bool up, BmsRegistArray *list, bool (*channel_check)( BmsWord ) ) {
  int direction = up ? 1 : -1; // ړ
  int head = up ? end : start; // ړ̓
  int tail = up ? start : end; // ړ̐K

  char *jump_str = list->take_at( BmsWord( head + direction ) );

  for ( int i = head; i != tail - direction; i -= direction ) {
    char *temp_str = list->take_at( BmsWord( i ) );
    list->overwrite_in( BmsWord( i + direction ), temp_str );
  }
  list->overwrite_in( BmsWord( tail ), jump_str );

  int max_position = bms->get_max_position();
  BmsWord jump_word( head + direction );
  BmsWord jumped_word( tail );
  BmsWord start_word( start ), end_word( end );

  for ( BmsChannel *temp_channel = bms->get_first_channel(); temp_channel != NULL_CHANNEL; temp_channel = temp_channel->get_next() ) {
    if ( (*channel_check)( temp_channel->get_channel_number() ) ) {
      for ( BmsChannel *same_channel = temp_channel; same_channel != NULL_CHANNEL; same_channel = same_channel->get_same_next() ) {
        for ( int i = 0; i <= max_position; ++i ) {
          if ( same_channel->at( i ) == "00" ) {
            // ׂ̈ɕKv
          }
          else if ( same_channel->at( i ) == jump_word ) {
            same_channel->overwrite( i, jumped_word );
          }
          else if ( same_channel->at( i ) >= start_word &&
                    same_channel->at( i ) <= end_word ) {
            same_channel->overwrite( i, BmsWord( same_channel->at( i ).get_int() + direction ) );
          }
        }
      }
    }
  }
}



// channelWAV or BMP̃`lǂ̊֐
static bool channel_check_wav( BmsWord channel ) {
  return (
    channel == "01" ||
    channel >= "11" && channel <= "1Z" ||
    channel >= "21" && channel <= "2Z" ||
    channel >= "31" && channel <= "3Z" ||
    channel >= "41" && channel <= "4Z" ||
    channel >= "51" && channel <= "5Z" ||
    channel >= "61" && channel <= "6Z" );
}
static bool channel_check_bmp( BmsWord channel ) {
  return (
    channel == "04" ||
    channel == "06" ||
    channel == "07" ||
    channel == "0A" ||
    channel == "A5" );
}


// BMSɃIuWF邩ǂ̃Xg쐬
void get_exist_list_wav( bool *list ) {
  get_exist_list( list, channel_check_wav );
}
void get_exist_list_bmp( bool *list ) {
  get_exist_list( list, channel_check_bmp );
}
void get_exist_list( bool *list, bool (*channel_check)( BmsWord ) ) {
  // Xg
  for ( int i = 0; i < BMS_OBJ_MAX; ++i ) { list[i] = false; }

  int max_position = bms->get_max_position();
  for ( BmsChannel *temp_channel = bms->get_first_channel(); temp_channel != NULL_CHANNEL; temp_channel = temp_channel->get_next() ) {
    if ( (*channel_check)( temp_channel->get_channel_number() ) ) {
      for ( BmsChannel *same_channel = temp_channel; same_channel != NULL_CHANNEL; same_channel = same_channel->get_same_next() ) {
        for ( int i = 0; i <= max_position; ++i ) {
          if ( same_channel->at( i ) != "00" ) { list[same_channel->at( i ).get_int()] = true; }
        }
      }
    }
  }
}
